org.multiverse.api.collections

## Interface TxnIterator<E>

All Superinterfaces:
  java.util.Iterator<E>

All Known Implementing Classes:
  AbstractTxnIterator

    public interface TxnIterator<E>
    extends java.util.Iterator<E>

### Method Summary

Methods
`boolean` `hasNext(Txn txn)` Returns `true` if the iteration has more elements.
`E` `next(Txn txn)` Returns the next element in the iteration.
`void` `remove(Txn txn)` Removes from the underlying collection the last element returned by the iterator (optional operation).

### Methods inherited from interface java.util.Iterator

`hasNext, next, remove`

### Method Detail

#### hasNext

    boolean hasNext(Txn txn)

Returns `true` if the iteration has more elements. (In other words, returns `true` if `next` would return an element rather than throwing an exception.)

Parameters:
  `txn` - Txn used for this operation
Returns:
  `true` if the iterator has more elements.

#### next

    E next(Txn txn)

Returns the next element in the iteration.

Parameters:
  `txn` - Txn used for this operation
Returns:
  the next element in the iteration.
Throws:
  `java.util.NoSuchElementException` - iteration has no more elements.

#### remove

    void remove(Txn txn)

Removes from the underlying collection the last element returned by the iterator (optional operation). This method can be called only once per call to `next`. The behavior of an iterator is unspecified if the underlying collection is modified while the iteration is in progress in any way other than by calling this method.

Parameters:
  `txn` - Txn used for this operation
Throws:
  `java.lang.UnsupportedOperationException` - if the `remove` operation is not supported by this Iterator.
  `java.lang.IllegalStateException` - if the `next` method has not yet been called, or the `remove` method has already been called after the last call to the `next` method.